# 基本地理坐标系换算工具代码库

本代码库主要包含基本的地理空间坐标系换算知识的代码实现。最初的推导并不是在WGS-84下，手稿非常悠久，也早已遗失。来自1980年代老一辈测绘工程师，彼时是在缺少互联网的情况下，使用纸笔在练习本上完成的。笔者作为实习生，在1990年代把一些公式从Z-80 BASIC （还有一版为GWBASIC）变为了Turbo C 2.0的代码。一晃40年过去了，在地理计算领域已经有成熟的很多开源库，老版本的软件已经无从寻找，那些青春记忆将随着我这代人的凋零而彻底沉入历史的海洋。

目前看来，从头推导、实现这些最为基础的空间算法只具备极其有限的学习价值。尽管如此，笔者还是准备陆续把想到的一些碎片拼凑起来，用当代Octave、 C /C++ 做一个推导、实现。全部代码均为内联代码，包含在一个独立的头文件中。所有方法与文档的推导一一对应，旨在辅助教学中深入算法内部，而不是只停留在使用现成的开源函数库。再次致敬使用计算尺和手摇计算机的老一代科技工作者，以及远去的三线建设、厂矿大院。

主要包括：

[1.WGS-84坐标系的基础换算](doc/1.wgs84.md)

[2.测地线与椭球最短路径计算](doc/2.geodesic.md)

[3.观测与遮挡](doc/3.azel.md)

[4.照射计算1](doc/4.light.md)

[5.照射计算2](doc/5.intersec.md)

[6.照射距离/俯仰等值线计算](doc/6.contour_dis_el.md)


后续将适时补充新的算法。

# 文档示意图
||||
|--|--|--|
|![1](images/ecef_geodesic.svg)|![1](images/ecef_calc.svg)|![1](images/enu_azel.svg)|
|![1](images/cover_torch.svg)|![1](images/HPR03.png)|![1](images/viscal.svg)|
|![1](images/example01.png)|![1](images/example02.png)|![1](images/example03.png)|
|![1](images/contour_distance.svg)|![1](images/example04.png)|![1](images/example05.png)|
# 声明

所有资源均只用于教学，误差、奇异点均没有经过严格测试，用于非教学场景造成的问题与开发者无关。地理信息绘图采用本工作室自行建立的另一个开源项目 qtv.planet，就在本仓库的同级。
